#!/usr/bin/perl -w

# Location of the usa_map.png file
my $PNG_FILE = "/var/www/cgi-bin/usa_map.png";

# Location of the map program
my $MAP_PROGRAM = "/var/www/cgi-bin/map";

# RGB color of states that will not be highlighted
my $NORMAL_COLOR = '128:128:128';

# RGB color of the text in the map
my $TEXT_COLOR = '0:0:0'; 

# Map of colors from those used in the URL to RGB values:
my %colorTable = (
   "1" => "255:0:0",
   "2" => "0:255:0",
   "3" => "0:0:255",
   "4" => "128:128:0",
   "5" => "0:128:128"
);

#----------------------------------------------------------------------------
# Nothing below here should need to be changed
#----------------------------------------------------------------------------

my @stateList = (
"AK", "AL", "AR", "AZ", "CA", "CO", "CT", "DC", "DE", "FL", "GA", "HI", "IA",
"ID", "IL", "IN", "KS", "KY", "LA", "MA", "ME", "MD", "MI", "MN", "MO", "MS",
"MT", "NC", "ND", "NE", "NH", "NJ", "NM", "NV", "NY", "OH", "OK", "OR", "PA",
"PR", "RI", "SC", "SD", "TN", "TX", "UT", "VA", "VT", "WA", "WI", "WV", "WY"
);

my $state;
my $states;
my $color;
my %colorHash;

use CGI qw(:standard);

my $query = new CGI;


foreach $state (@stateList) {
   next unless (defined($color = $query->param($state)));
   $colorHash{$color} .= uc($state) . ":";
}

my $cmdLine = "";

while (($color, $states) = each (%colorHash)) {
   next unless (defined($colorTable{$color}));
   # Get rid of the last : in each state list
   $states =~ s/:$//;
   $cmdLine .= " " . $colorTable{$color} . " " . $states;
}

binmode STDOUT;

print "Content-type: image/png\n";
print "Expires: 0\n\n";

system ("echo $MAP_PROGRAM $PNG_FILE $TEXT_COLOR $NORMAL_COLOR $cmdLine > /tmp/foo");

system("$MAP_PROGRAM $PNG_FILE $TEXT_COLOR $NORMAL_COLOR $cmdLine");
 
